#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "fire2700seven4xi .py">
#<abstract4xi abstract = "fires to direction seven and to distance 2700"/>
#<verify4xi verification = "11" target = "verb4xi.py"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'fire2700seven4xi ']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread
import _winapi
   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "


from time4xi import time4xi

#"
#/>
       
       
# -------------------------------------------------------------------------------------------------
# SHOT2SEVEN - COORDINATE SIGNS OF SHOOT2SEVEN4XI: (X - ,Y - ,Z + )
# -------------------------------------------------------------------------------------------------    
global shot2seven27004xi


#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = False
shot2seven27004xi = {
                1:'-1031x-870y2338z',
                2:'-1037x-2066y1393z',
                3:'-1039x-2335y867z',
                4:'-1039x-973y2410z',
                5:'-1057x-800y2351z',
                6:'-1078x-731y2364z',
                7:'-1094x-661y2377z',
                8:'-1106x-592y2390z',
                9:'-110x-1380y2317z',
                10:'-1114x-523y2402z',
                11:'-1118x-455y2415z',
                12:'-112x-2413y1204z',
                13:'-1137x-1997y1416z',
                14:'-1156x-2270y893z',
                15:'-1232x-1922y1439z',
                16:'-1269x-2198y918z',
                17:'-1323x-1843y1462z',
                18:'-136x-2607y686z',
                19:'-1377x-2121y944z',
                20:'-1380x-2320y6z',
                21:'-1408x-1760y1484z',
                22:'-1481x-2038y969z',
                23:'-1489x-1673y1507z',
                24:'-1499x-2245y33z',
                25:'-1563x-1582y1529z',
                26:'-1579x-1950y994z',
                27:'-1614x-2163y60z',
                28:'-1633x-1487y1551z',
                29:'-1672x-1857y1019z',
                30:'-1696x-1390y1573z',
                31:'-1725x-2075y87z',
                32:'-1754x-1290y1595z',
                33:'-1760x-1760y1044z',
                34:'-179x-1349y2331z',
                35:'-1806x-1188y1617z',
                36:'-1830x-1981y114z',
                37:'-1842x-1658y1069z',
                38:'-1851x-1083y1639z',
                39:'-1891x-977y1660z',
                40:'-1918x-1553y1094z',
                41:'-1924x-870y1681z',
                42:'-1931x-1881y141z',
                43:'-1951x-762y1702z',
                44:'-1972x-653y1723z',
                45:'-1987x-545y1744z',
                46:'-1988x-1444y1118z',
                47:'-1996x-436y1764z',
                48:'-2025x-1777y168z',
                49:'-2051x-1332y1143z',
                50:'-2108x-1217y1167z',
                51:'-2114x-1667y195z',
                52:'-2158x-1099y1191z',
                53:'-2197x-1553y222z',
                54:'-2202x-980y1216z',
                55:'-2239x-859y1240z',
                56:'-2269x-737y1264z',
                57:'-2273x-1434y248z',
                58:'-2292x-614y1287z',
                59:'-2308x-490y1311z',
                60:'-2317x-367y1335z',
                61:'-2320x-243y1358z',
                62:'-2343x-1312y275z',
                63:'-237x-2392y1228z',
                64:'-2406x-1186y302z',
                65:'-245x-1315y2345z',
                66:'-2462x-1058y329z',
                67:'-24x-26y2699z',
                68:'-2510x-926y356z',
                69:'-2552x-792y383z',
                70:'-2586x-657y409z',
                71:'-25x-385y2672z',
                72:'-272x-2589y712z',
                73:'-308x-1277y2358z',
                74:'-360x-2364y1252z',
                75:'-368x-1237y2371z',
                76:'-38x-1407y2304z',
                77:'-406x-2564y738z',
                78:'-40x-48y2699z',
                79:'-424x-1193y2384z',
                80:'-42x-356y2675z',
                81:'-477x-1147y2396z',
                82:'-481x-2330y1276z',
                83:'-526x-1099y2409z',
                84:'-538x-2532y764z',
                85:'-54x-72y2698z',
                86:'-56x-327y2679z',
                87:'-571x-1049y2421z',
                88:'-599x-2289y1300z',
                89:'-612x-997y2433z',
                90:'-650x-943y2444z',
                91:'-65x-97y2697z',
                92:'-668x-2493y790z',
                93:'-683x-889y2455z',
                94:'-68x-298y2682z',
                95:'-6x-412y2668z',
                96:'-6x-6y2699z',
                97:'-713x-833y2467z',
                98:'-714x-2242y1323z',
                99:'-739x-776y2477z',
                100:'-74x-124y2696z',
                101:'-755x-139y2588z',
                102:'-760x-720y2488z',
                103:'-76x-268y2685z',
                104:'-772x-184y2580z',
                105:'-778x-663y2498z',
                106:'-786x-231y2572z',
                107:'-792x-606y2508z',
                108:'-795x-2447y816z',
                109:'-797x-281y2564z',
                110:'-802x-549y2518z',
                111:'-805x-332y2555z',
                112:'-808x-493y2528z',
                113:'-809x-384y2546z',
                114:'-80x-151y2694z',
                115:'-810x-438y2537z',
                116:'-81x-238y2688z',
                117:'-825x-2189y1347z',
                118:'-83x-180y2692z',
                119:'-83x-209y2690z',
                120:'-919x-2394y842z',
                121:'-933x-2130y1370z',
                122:'0x-2617y660z'}         
#"
#/>


# -------------------------------------------------------------------------------------------------
#<function4xi function = "fire2700seven4xi " usage = "target function for charge2seven4xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def fire2700seven4xi (queue2seven, consumer_channel2seven, publisher_channel2seven):
    '''
    returns (x,y,z) coordinates via queue
    '''
    
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    if ack2debug is True:
        print("\n (STEP 1A1/33) OF FIRE2700SEVEN4XI - STARTED TIME: ", time2start)
        #  
        
        print("\n (STEP 1A2/33) OF FIRE2700SEVEN4XI -  QUEUE2SEVEN: ", queue2seven)      
        # 
        
        print("\n (STEP 1A3/33) OF FIRE2700SEVEN4XI -  CONSUMER_CHANNEL2SEVEN: ", consumer_channel2seven)
        # 
              
        print("\n (STEP 1A4/33) OF FIRE2700SEVEN4XI -  PUBLISHER_CHANNEL2SEVEN: ", publisher_channel2seven)          
        # 
        


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # QUEUE RETURNING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ack2put = False
    if ack2debug is True:
        print("\n (STEP 2A/33) OF FIRE2700SEVEN4XI - TRYING TO RETURN BY PUTTING COORDINATE DICTIONARY TO QUEUE2SEVEN: ", queue2seven, " - TIME: ", time4xi()) 
        # 
         
    try:
        # ------------------------------------------------------------------------------------- 
        # PUT SHOT TO QUEUE 
        # -------------------------------------------------------------------------------------                 
        queue2seven.put(shot2seven27004xi) 
        if ack2debug is True:
            print("\n (STEP 2B/33) OF FIRE2700SEVEN4XI - SUCCEEDED TO PUT COORDINATE DICTIONARY TO QUEUE2SEVEN: ", queue2seven, " - TIME: ", time4xi()) 
            # 
             
        ack2put = True
    except:
        print("\n (STEP 2C/33) OF FIRE2700SEVEN4XI *** FAILED TO PUT COORDINATE DICTIONARY TO QUEUE2SEVEN: ", queue2seven, " - TIME: ", time4xi()) 
    
    if ack2debug is True:
        print("\n (STEP 3A/33) OF FIRE2700SEVEN4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL2SEVEN: ", publisher_channel2seven, " - TIME: ", time4xi())
        # 
         
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL 
        # ---------------------------------------------------------------------------------------------
        if ack2put is True:
            message2send4one = "<ack2put4xi>queue2seven8shot2seven27004xi </ack2put4xi>"
        else:
            message2send4one = "<nack2put4xi>queue2seven8shot2seven27004xi </nack2put4xi>" 
            
        publisher_channel2seven.send(message2send4one)
        if ack2debug is True:    
            print(" (STEP 3B/33) OF FIRE2700SEVEN4XI -  SENT MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2SEVEN: ", publisher_channel2seven, " - TIME: ", time4xi()) 
            #  
        
    except:
        print(" (STEP 3C/33) OF FIRE2700SEVEN4XI *** FAILED TO SEND MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2SEVEN: ", publisher_channel2seven, " - TIME: ", time4xi()) 
    
    if ack2debug is True:        
        print("\n (STEP 3D/33) OF FIRE2700SEVEN4XI - RETURNING QUEUE OBJECT QUEUE2SEVEN: ", queue2seven, " - TIME: ", time4xi())  
        # 
            
    return queue2seven    
        
           
#</function4xi>


#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_verb4xi.txt
#   sense-test-verb4xi.xml
#   reason-test-verb4xi.xml
#   ace-test-verb4xi.xml
#"
#>



# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of fire2700seven4xi .py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>

       